import { world, Entity, system } from '@minecraft/server'

world.afterEvents.itemUse.subscribe((eventData) => {
    const player = eventData.source;
    const item = eventData.itemStack;
    if (item.typeId.includes("sword") || item.typeId.includes("pickaxe") &&
        !hook(player)) {
        player.runCommand(`/function swing`);
        player.runCommand(`/event entity @e[type=arrow,tag="${player.id}"] instant_despawn`);
    }
});

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        if (hook(player)) {
            const pHook = hook(player)
            const hookX = Math.floor(pHook.location.x)
            const hookY = Math.floor(pHook.location.y)
            const hookZ = Math.floor(pHook.location.z)
            player.runCommand(`tp @e[type=arrow,tag="${player.id}"] ${hookX} ${hookY} ${hookZ} facing @s`)
            const viewD = pHook.getViewDirection();
            player.applyKnockback(viewD.x, viewD.z, (viewD.x ** 2 + viewD.z ** 2) * -10, (viewD.y * 0.3) * -10)
            player.runCommand(`event entity @e[type=arrow,tag="${player.id}"] instant_despawn`)
            player.runCommand(`/function killlead`)
            player.removeTag("wee")
        }
    }
});

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        if (player.hasTag("shootHook")) {
            player.removeTag("shootHook")
            const dim = player.dimension
            const pos = player.location
            const direction = player.getViewDirection()

            const spawn = dim.spawnEntity("minecraft:arrow<arrow_hook>", {
                x: pos.x + direction.x * 1.5,
                y: pos.y + 1.5 + direction.y * 1,
                z: pos.z + direction.z * 1.5
            });
            spawn.addTag(player.id)
            const lead = spawn.getComponent("leashable")
            const projectil = spawn.getComponent("projectile")
            lead.leashTo(player)
            projectil.owner = player
            const impulse = {
                x: direction.x * 5,
                y: direction.y * 5,
                z: direction.z * 5
            };
            projectil.shoot(impulse)
        }
    }
});

world.afterEvents.projectileHitBlock.subscribe((eventData) => {
    const projectile = eventData.projectile
    if (projectile.typeId == "minecraft:arrow") {
        projectile.addTag("hit")
    }
});

world.afterEvents.entityHurt.subscribe((eventData) => {
    const source = eventData.damageSource
    const projectile = source.damagingProjectile
    const hurt = eventData.hurtEntity
    if (projectile && projectile.typeId === "minecraft:arrow" && hurt.typeId !== "minecraft:player") {
        projectile.addTag("hit")
    }
});

function hook(player) {
    for (const entity of player.dimension.getEntities()) {
        if (entity.hasTag(player.id) && entity.hasTag("hit") && entity.typeId == "minecraft:arrow") {
            return entity
        }
    }
};